function localeHelp(text) {
    var s = NSG.root.getHelp(text);
    s = s.replace(/^uitcp_/,"");
    return s;
}

function escLua(s) {
    return s.replace(/(['"])/g,"\\$1"); // "'
};

function escJQ(s) {

    return s.replace(/([#;&,.+*~':"!^$[\]()=>|])/g,"\\$1");// "'
};

function ui_UnHide( eThis , expand){
    var li = findParentByTag(eThis, 'LI', 6);
    var ret;
    if(li) {
        if( (typeof(expand) != 'undefined' && expand>0 ) || ($(li).hasClass("ui_cl") && ! (typeof(expand) != 'undefined' && expand==0 )) ){
            ret = ! $(li).hasClass("ui_ex");
            $(li).addClass("ui_ex").removeClass("ui_cl");
	    setCookie("UI_LC_" + (NSG.left.groupBy || 'none') + "." + buildPath(li,"."),"e");
        }else{
            ret = ! $(li).hasClass("ui_cl");
            $(li).addClass("ui_cl").removeClass("ui_ex");
	    delCookie("UI_LC_" + (NSG.left.groupBy || 'none') + "." + buildPath(li,"."));
        }
    }
    return ret;
}



function setContent(eThis) {
    NSG.root.CONTENT = "";
    do {
        eThis = $(eThis).parent().closest("li.ui_tunnel, li.ui_channel");
        if(eThis.size()==0)
            break;
        NSG.root.CONTENT=  $(eThis).attr('name') + "," + NSG.root.CONTENT;
    }
    while (1);
    NSG.root.CONTENT = "{" + NSG.root.CONTENT + "}";
    NSG.root.update();
}


function genLi(name, className , text) {
    var li = NSG.left.createElement("LI");
    $(li).addClass(className);
    $(li).attr('name', '"'+ escLua(name)+'"');
    $(li).attr('id', name);
    li.innerHTML = "<table class=\"ui_node\">"+
        "<tbody>"+
        "<tr valign=\"middle\">"+
        "<td>"+
        "<a class=\"ui_sc\" onclick=\" NSG.root.ui_UnHide(this); return false;\" title=\"header=[webBtnExpand] body=[]\">"+
        "<img class=\"bexpand\" src=\"/nil.png\"/>"+
        "</a>"+
        "<a class=\"ui_sch\" onclick=\" NSG.root.ui_UnHide(this); return false;\" title=\"header=[webBtnCollapse] body=[]\">"+
        "<img class=\"bcollapse\" src=\"/nil.png\"/>"+
        "</a>"+
        "</td>"+
        "<td class=\"ui_param\" width=\"120\" title=\"\">"+
        "<span class=\"ui_dir\">"+
        "<a class=\"ui_name\" onclick=\" NSG.root.setContent(this); return false;\" onkeydown=\"NSG.root.paramKeyDown(event, this)\" href=\"javascript:void(0)\">"+text+"</a>"+
        "</span>"+
        "<input class=\"ui_value\" type=\"hidden\" value=\"sys\" name=\"sys\"/>"+
        "</td>"+
        "<td class=\"ui_value\"> </td>"+
        "<td class=\"ui_itemcontrols\"> </td></tr>"+
        "</tbody>"+
        "</table>"+
        "<div class=\"ui_dir\">"+
        "<div class=\"ui_dircontrol\">"+
        "</div>"+
        "<ul>  </ul>"+
        "</div>";
    return li;
};

menuTree = {
    "tuns":{},
    "groups":{},
    "name":"none"
};


function selectGroup(tree, tun){
    var STATE = 0;
    var GROUP = 2;
    var CERTGOOD = 3;
    var BACKUP = 4;
    menuTree.node = menuTree.node ? menuTree.node : $("ul.ui_root",NSG.left)[0];
    menuTree.ul_node = menuTree.node;
    var res = menuTree;
    if ((NSG.left.groupBy || 'none') != 'none') {
	var group;
	switch(NSG.left.groupBy) {
	case 'group':
	    group = tree[tun][GROUP];
	    break;
	case 'state':
	    group = tree[tun][STATE]=="normal" ? (tree[tun][BACKUP]=="true" ? "backup" :"normal" ) : tree[tun][STATE];
	    break; 
	case 'cert':
	    group = tree[tun][CERTGOOD]=="true" ? localeHelp("uitcp_goodCerts") : localeHelp("uitcp_expiredCerts");
	    break;   
	case 'name1':
	    var patt1=new RegExp("^[^#$%^&*()./\\|_@+-]+");
	    group = patt1.exec(tun);
	    break;
	case 'name2':
	    var patt1=new RegExp("^[a-zA-Z]+");
	    group = patt1.exec(tun);
	    break;
	case 'name3':
	    var patt1=new RegExp("^[0-9]+");
	    group = patt1.exec(tun);
	    break;    
	case 'name4':
	    var patt1=new RegExp("^.");
	    group = patt1.exec(tun);
	    break; 
	    
	}
	
	if($.isArray(group))
	    group = group[0];
	
	if(!group || group == '')
	    group = 'default group';

	if(menuTree.groups[group])
	    res = menuTree.groups[group];
	else {
	    var path =  buildPath($(menuTree.ul_node).closest("li")[0]);
	    path =  "UI_LC_" + (NSG.left.groupBy || 'none') + "." + (path=="" ? "" : path + ".") + '"' + escLua(group) + '"';
	    $(menuTree.ul_node).append(genLi(group,"ui_"+ (getCookie(path)=="e" ? "ex" : "cl") +" ui_group","<span class=\"ui_group\">"+ group+"</span>")).children("li").tsort("",{attr:"name"});
	    menuTree.groups[group] = {'node':$('li[id="'+group+'"]', menuTree.ul_node),'ul_node':$('li[id="'+group+'"] ul', menuTree.ul_node), 'name':group};
	    res = menuTree.groups[group];
	    
	}
	
    }
    if (menuTree.groups[res.name])
	delete menuTree.groups[res.name].old;
    menuTree.groups[res.name] = res;
    return res;
}

function addChannel(menuTun, treeTun, chan) {
    var host = 0;
    var port = 1;
    var peerHost = 2;
    var peerPort = 3;
    var direction = 4;
    var CHANS = 1;//channels
    var text = "<nobr>["+chan+"] " + treeTun[CHANS][chan][peerHost] +":"+ treeTun[CHANS][chan][peerPort] + " " + treeTun[CHANS][chan][direction] + " " + treeTun[CHANS][chan][host] +":"+ treeTun[CHANS][chan][port] + "</nobr>";
    $(menuTun.ul_node).append(genLi(chan, "ui_channel", text)).tsort("li",{attr:"name"});
    menuTun.chans[chan] = {'node':$('li[id="'+chan+'"]', menuTun.node)};
};
function addTunnel(tree, tun, group) {
    var STATE = 0;
    var CHANS = 1;
    var GROUP = 2;
    var CERTGOOD = 3;
    var BACKUP = 4;
    var path = buildPath($(group.ul_node).closest("li")[0]);
    path =  "UI_LC_" + (NSG.left.groupBy || 'none') + "."  + (path=="" ? "" : path + ".") + '"' + escLua(tun) + '"';
	    
    $(group.ul_node).append(genLi(tun,"ui_"+ (getCookie(path)=="e" ? "ex" : "cl") +" ui_tunnel","<span class=\"ui_"+tree[tun][STATE]+tree[tun][BACKUP]+" ui_cert"+ tree[tun][CERTGOOD] +"\">"+ tun+"</span>")).children("li").tsort("",{attr:"name"});

    menuTree.tuns[tun] = {'node':$(group.ul_node).children('li[id="'+tun+'"]'),'ul_node':$('ul',$(group.ul_node).children('li[id="'+tun+'"]')),'state':tree[tun][STATE],'certgood':tree[tun][CERTGOOD],'group':group.name, chans:{}};
    var ch;
    for(ch in tree[tun][CHANS]) {
	addChannel(menuTree.tuns[tun], tree[tun], ch);
    }
};

function updateTree(tree){
    var STATE = 0;
    var CHANS = 1;//channels
    var GROUP = 2;
    var CERTGOOD = 3;
    var BACKUP = 4;
    var tun;
    for(tun in menuTree.tuns){
	menuTree.tuns[tun].old = true;
    }
    var group;
    for(group in menuTree.groups){
	if (menuTree.groups[group] != menuTree) {
	    menuTree.groups[group].old = true;
	}
    }
    for(tun in tree) {
	var group = selectGroup(tree, tun);
	if(menuTree.tuns[tun] && (menuTree.tuns[tun].group == group.name)) {
	    delete menuTree.tuns[tun].old;
	    if(tree[tun][STATE] != menuTree.tuns[tun].state || tree[tun][CERTGOOD] != menuTree.tuns[tun].certgood || tree[tun][BACKUP] != menuTree.tuns[tun].backup) {
		//change state
		$("table.ui_node td.ui_param span.ui_dir span.ui_"+menuTree.tuns[tun].state+menuTree.tuns[tun].backup, menuTree.tuns[tun].node).removeClass().addClass("ui_"+tree[tun][STATE]+tree[tun][BACKUP]).addClass("ui_cert"+tree[tun][CERTGOOD]);
		menuTree.tuns[tun].state = tree[tun][STATE];
		menuTree.tuns[tun].certgood = tree[tun][CERTGOOD];
		menuTree.tuns[tun].backup = tree[tun][BACKUP];
	    }
	    var ch;
	    for(ch in menuTree.tuns[tun].chans) {
		menuTree.tuns[tun].chans[ch].red = menuTree.tuns[tun].chans[ch].old;
		menuTree.tuns[tun].chans[ch].old = true;
	    }
	    for(ch in tree[tun][CHANS]) {
		if(menuTree.tuns[tun].chans[ch]) {
		  delete menuTree.tuns[tun].chans[ch].old;
		  delete menuTree.tuns[tun].chans[ch].red; 
		} else{
		    //make new channel
		    addChannel(menuTree.tuns[tun], tree[tun], ch);
		}
	    }
	    for(ch in menuTree.tuns[tun].chans) {
		if(menuTree.tuns[tun].chans[ch].old) {
		   $(menuTree.tuns[tun].chans[ch].node).addClass("red"); 
		}
		if(menuTree.tuns[tun].chans[ch].red) {
		    $(menuTree.tuns[tun].chans[ch].node).remove();
		    delete menuTree.tuns[tun].chans[ch];
		}
	    }
	} else if(menuTree.tuns[tun] && (menuTree.tuns[tun].group != group.name)) {
	    //move tun to other group === recreate it
	    $(menuTree.tuns[tun].node).remove(); 
	    delete menuTree.tuns[tun];
	    addTunnel(tree, tun, group);
	} else {
	    //make new tunnel  
	    addTunnel(tree, tun, group);
	}
    }
    var tun ;
    for(tun in menuTree.tuns){
	if(menuTree.tuns[tun].old){
	   $(menuTree.tuns[tun].node).remove(); 
	    delete menuTree.tuns[tun];
	}
    } 
    var group;
    for(group in menuTree.groups){
	if(menuTree.groups[group].old && menuTree.groups[group] != menuTree){
	   $(menuTree.groups[group].node).remove(); 
	    delete menuTree.groups[group];
	}
    }
}

newSID = function(sid){
    SID = sid;
    AUTH="locale="+LOCALE+"&module="+MODULE+"&sesnum."+encodeURIComponent(NETNS)+"."+encodeURIComponent(LOGIN)+"="+SID+"&login="+LOGIN+"&netns="+NETNS+ "&pass=" + PASS +"&path=" + PATH + "&maxRights=user&";
    setCookie("sesnum." + NETNS +"."+LOGIN, SID);

}

update = function (){
    with(NSG.root) {
        if(TIMER) {
            clearTimeout(TIMER);
            TIMER=null;
        }
        if (REQUEST) {
            REQUEST.abort();
            REQUEST = null;
        }
        $("body div.ui_head img.brefresh", NSG.top).removeClass().addClass("brefreshactive").attr("src","/loading.gif");
        REQUEST = $.post("/",
                         "command=getHTML&subcmd=update&content="+encodeURIComponent(CONTENT)+"&"+AUTH,
                         function(data) {
                             //alert(data);
                             with(NSG.root) {
                                 $("body div.ui_head img.brefreshactive", NSG.top).removeClass().addClass("brefresh").attr("src","/nil.png");
                                 REQUEST = null;
                                 eval('[function (){' + data + '}][0]')();

                                 $("span.locale",NSG.right).html(
                                     function(index, text) {
					 return localeHelp(text);                                         
                                     }).removeClass().addClass("located");

                                 if(TIMER) {
                                     clearTimeout(TIMER);
                                     TIMER=null;
                                 }
                                 TIMER = setTimeout('update()',($("select.ui_period", NSG.top).val() || 60)*1000);
                             }
                         });
    }
};

var NSG;


function onLoad(){
    NSG.root = window;
    NSG.left.NSG = NSG;
    NSG.right.NSG = NSG;
    NSG.top.NSG = NSG;
    $("head",NSG.left).html('<style>html {padding-right:1px; border-right:1px solid #6699cc; height:100%; }</style>');
    $("body",NSG.left).html('<table width="100%" class="ui_menu">' +
        '<tr height="300px"  class="ui_center" valign="top"><td class="ui_menu">' +
        '<div class="ui_menu"><span class="ui_dir">' +
        '<a class="ui_name" onclick="NSG.root.CONTENT=\'{}\'; NSG.root.update(); return false;" onkeydown=" NSG.root.paramKeyDown(event, this);" href="javascript:void(0)">SUMMARY</a><br>' +
                            '</span><ul id="root" class="ui_root"></ul></div></td></tr></table>');

    $("body",NSG.top).html("<div class=\"ui_head\"><table width=\"100%\" class=\"ui_head\"><tr><td width=\"20px\"><nobr>&nbsp;&nbsp;&nbsp;"+NSG.root.LOGIN+"&nbsp;&nbsp;&nbsp;<img class=\"brefreshactive\" tabindex=0  onkeydown=\"return NSG.root.btnKeyDown(event,this);\" onclick=\"NSG.root.update();return false;\" src=\"/loading.gif\" alt=\"*\" ><select class=\"ui_period\" onchange=\"NSG.root.setCookie('UI_interval',this.value); NSG.root.update();return false;\"><option value=10>10sec</option><option value=20>20sec</option><option selected value=60>1min</option><option value=300>5min</option><option value=900>15min</option></select>&nbsp;&nbsp;&nbsp;<img class=\"ui_tree\" title=\"Group by\" alt=\"Group by\" src=\"/nil.png\"><select class=\"ui_group\" onchange=\"NSG.left.groupBy=this.value;NSG.root.setCookie('UI_group_by',this.value); NSG.root.update();return false;\"><option value=\"none\" selected>none</option><option value=\"group\">group</option><option value=\"name1\">name1(*[punct]*)</option><option value=\"name2\">name2([alpha]*)</option><option value=\"name3\">name3([digit]*)</option><option value=\"name4\">alphabet</option><option value=\"state\">state</option><option value=\"cert\">cert expiration</option></select>&nbsp;<img class=\"blogout\" onclick=\"NSG.root.logOut(); return false;\" title=\"\" alt=\"Logout\" src=\"/nil.png\" tabindex=\"0\" onkeydown=\"return btnKeyDown(event,this);\"</nobr></td><td>NSG <i onclick=\"NSG.root.showLeakChecker();\">ui</i>TCP Client/Server Viewer</td></tr></table></div>");
    $("head",NSG.right).html('<style>html {padding-left:1px; border-left:1px solid #6699cc; height:100%; text-align:center; }</style>');

    loadJSTo("boxover.js?"+NSGVERSION, NSG.left);
    loadJSTo("boxover.js?"+NSGVERSION, NSG.right);
    loadJSTo("boxover.js?"+NSGVERSION, NSG.top);

    loadCSSTo("style.css?"+NSGVERSION, NSG.left);
    loadCSSTo("uitcpstyle.css?"+NSGVERSION, NSG.left);
    loadCSSTo("style.css?"+NSGVERSION, NSG.right);
    loadCSSTo("uitcpstyle.css?"+NSGVERSION, NSG.right);
    loadCSSTo("style.css?"+NSGVERSION, NSG.top);
    loadCSSTo("uitcpstyle.css?"+NSGVERSION, NSG.top);
    $("select.ui_period",NSG.top).val(NSG.root.getCookie('UI_interval'));
    $("select.ui_group",NSG.top).val(NSG.root.getCookie('UI_group_by'));
    NSG.left.groupBy = $("select.ui_group",NSG.top).val();
    NSG.root.update();
};

logOut = function (force) {
    REQUEST = $.post("/",
                     "command=getHTML&subcmd=close&"+AUTH,
                     function() {
                         if(NSG.root.TARGET=='_self')
			     NSG.root.location.replace(window.location.toString());
			 else
			     NSG.root.close();
                     });
}
