package.path = "/etc/nsg/share/lua/5.1/?.lua;"..package.path
package.cpath = "/etc/nsg/lib/lua/5.1/?.so;"..package.cpath

module(..., package.seeall)
local T1 = os.clock()
local conf = require'nsgconf'
local nsg = require'nsg'

local nsgPageName = nsgPageName -- get from parent script
local urlDecode
local htmlEncode
local doCmdXML
local loginPage
local genOut
local genError
local genFast
local usec
local bodyPrint
local stdHead
local fstr
local calcValue
local initPostData
local initEnvData
local headPrint
local htmlDecode
local checkPasswd
local selectLanguage
local explodeToTable
local tokens
local readpopen = nsg.readpopen
local fixCRLF
local splitString
local escapeForScript
local script
local hideCTRL
local text
local textXML
local alert
local xmlHead
local parseCookie
local NETNS = nsg.readpopen('echo -n $NETNS'):gsub('[^a-zA-Z0-9]','')
local version = nsg.getVersion()
local luaToHuman = nsg.luaToHumanUTF8

--[[

We need help for this strings

_H = "webJobs"
_H = "webBtnExpand"
_H = "webBtnCollapse"
_H = "webBtnLogout"
_H = "webBtnUsage"
_H = "webBtnEditSave"
_H = "webBtnValidate"
_H = "webBtnUndo"
_H = "webBtnManual"
_H = "webBtnKey"
_H = "webBtnEdit"
_H = "webBtnRefresh"
_H = "webDlgAddName"
_H = "webBtnAdd"
_H = "webBtnApply"
_H = "webBtnSave"
_H = "webBtnDel"
_H = "webBtnStartEdit"
_H = "webBtnHTML"
_H = "webBtnClearDir"
_H = "webBtnClearDirConfirm"
_H = "webBtnApplyCfgConfirm"
_H = "webBtnRun"
_H = "webBtnShowConf"
_H = "webDlgDelete"
_H = "webBtnDisable"
_H = "webNationalAlphabet"
_H = "webTtyOnline"
_H = "webTtyCtrlKey"
_H = "webTtyClosed"
_H = "webTtyClosing"

--]]

urlDecode = function(s)
               return (string.gsub (string.gsub (tostring(s or ""), "+", " "),
                                    "%%(%x%x)",
                                    function (str)
                                       return string.char (tonumber (str, 16))
                                    end )
                    )
            end

htmlEncode = function(s)
                return string.gsub( string.gsub (string.gsub (string.gsub (tostring(s or ""), "&", "&amp;"),
                                                              "\"",
                                                              "&quot;"),
                                                 "<",
                                                 "&lt;"),
                                    ">",
                                    "&gt;")
             end

htmlDecode = function(s)
                return string.gsub( string.gsub (string.gsub (string.gsub (tostring(s), "&qt;", ">"),
                                                              "&quot;",
                                                              "\""),
                                                 "&lt;",
                                                 "<"),
                                    "&amp;",
                                    "&")
             end

local devName = htmlEncode(readpopen("cat /proc/nsg/env | grep nsg_device | grep -oe '[^=]*$'"))
local hostName =  htmlEncode(readpopen("hostname"))

local old_checkPasswd = function(login, pass)
                 require"posix"
                 local f
                 f = io.open("/etc/shadow", "r")
                 if not f then
                    return false
                 end
                 local hash
                 hash = f:read("*a")
                 if not hash then
                    return false
                 end
                 f:close()
                 --print(hash)
                 hash = string.match(hash, "[^%W]*"..login..":([^:]*):")
                 --print(hash)
                 if not hash then
                    return false
                 elseif hash=="" then
                    return true
                 else
                    local res
                    local res2
                    res,res2 = pcall(posix.crypt,pass,hash)
                    if res and res2==hash then
                       return true
                    else
                       return false
                    end
                 end
                 return false
              end


checkPasswd = function(login, pass)
                 if login==nil or pass==nil then
                    return false
                 end
                 local res = nsg.pamAuth('login', login, pass)
                 if not res then
                    return old_checkPasswd(login, pass)
                 else
                    return res
                 end
end

stdHead = function (http, mode)
             --http:headPrint("HTTP/1.0 200 OK")
             http:headPrint("Status", "200")
--             http:headPrint("Content-Type", "text/html")
             http:headPrint("Cache-Control", "no-store, no-cache, must-revalidate")
             http:headPrint("Cache-Control", "post-check=0, pre-check=0")
          end

fstr = function (...)
          return table.concat({...})
       end

calcValue = function (valString, raw)
               if not raw then
                  valString = valString:match"^%s*(.-)%s*$" or ''
               end
               if valString == '' or valString == 'nil' then
                  valString = nil
               else
		  --quoted and escaped string
                  local res, value, v1 = pcall(loadstring('setfenv(1, {})return '..valString))
		  --escaped string
		  if not res or value == nil or v1 then
		     res, value, v1 = pcall(loadstring('setfenv(1, {})return "'..(valString:gsub('\\*"',
												 function(str)
												    if(str:len() %2 == 1) 
												    then
												       return str:gsub('"','\\"')
												    else
												       return str
												    end
												 end))..'"' ))
		  end
		  --just in case of some error
                  if not res or value == nil or v1 then
                     res, valString = pcall(loadstring('setfenv(1, {})return '..
                                                       string.format('%q', valString)))
                  else
                     valString = value
                  end
                  if not res then valString = nil end
               end
               return valString
            end

parseCookie = function (cookie)
                 res = {}
                 for s1,s2 in string.gmatch(';'..cookie..';', '%s*([^;=]+)%s*%=([^;]*)') do
                    res[urlDecode(s1)] = urlDecode(s2)
                 end
                 return res
              end

initPostData = function (http)
                  if nsgServer == "xavante" then
                     http.data = cgilua.POST
                     for k,v in pairs(http.data) do
                        if type(v)=="table" and v.file then
                           local buf = "XX"
                           v.tmpFile = os.tmpname()
                           local f = io.open(v.tmpFile,"w")
                           while type(buf)=='string' and #buf>0 do
                              buf = v.file:read(1024*1024)
                              f:write(buf or "")
                           end
                           f:close()
                        end
                     end
                  else
                     if( http.env.request_method == 'POST' and
                         -- string.match(http.env.content_type,'application\/x-www-form-urlencoded') and
                         tonumber(http.env.content_length) > 0 )
                     then
                        local x=0
                        -- !!!  Don`t read more then http.env.content_length
                        for line in io.lines() do
                           http.raw_post = http.raw_post .."\010".. line;
                           for s1,s2 in string.gmatch('&'..line..'&', '([^&=]*)%=([^&]*)') do
                              http.data[urlDecode(s1)] = urlDecode(s2)
                           end
                           x = x + string.len(line)+1
                           if x >  tonumber(http.env.content_length) then
                              break
                           end
                        end
                     end

                     -- override POST data through url string
                     local x1,x2,params = string.find(http.env.request_uri or '', '?(.*)$')
                     for s1,s2 in string.gmatch((params or "") ..'&', '([^&=]*)%=([^&=]*)') do
                        http.data[s1] = s2
                     end
                  end
               end

tokens = function (s, delim)
   local pos = 1
   return function()
             local f, l = string.find(s, '[^'..delim..']+', pos)
             if f then
                pos = l + 1
                return string.sub(s, f, l)
             else
                return nil
             end
          end
end

explodeToTable = function (path, delim)
   local pathTable = {}
   for s in tokens(path, delim) do
      table.insert(pathTable, s)
   end
   return pathTable
end

selectLanguage = function (http_lang)
   local langTokens = explodeToTable(http_lang or "ru", ",")
   local lang = {};
   local maxLang = "ru"
   local maxQ = 0
   local l,q
   for k,v in ipairs(langTokens) do

      l, q = string.match( string.gsub(v, "%s", "") , "([a-zA-Z][a-zA-Z])([;]*)([q=]*)([0-9.]*)")

      if((q == nil) or (q=="")) then
         q =  1000
      else
         q = string.match(q, ";q=([0-9.]*)" )
         if((q == nil) or (q=="")) then
            q =  1000
         else
            q = tonumber(q)
         end
      end
      l = l or "en"
      --print("//".. l .."~".. tostring(q))
      if(type(lang[l]) == "number") then
         lang[l] = ((tonumber(q) > lang[l]) and q) or lang[l]
      else
         lang[l] = tonumber(q)
      end

      if maxQ < lang[l] then
         maxQ = lang[l]
         maxLang = l
      end
   end
   return maxLang
end


initEnvData = function (http)
                 if (nsgServer == "xavante") then
                    http.env['lang'] = selectLanguage(cgilua.servervariable("HTTP_ACCEPT_LANGUAGE"))
                    http.env['auth_type'] =     cgilua.servervariable("AUTH_TYPE")
                    http.env['gateway_interface'] = cgilua.servervariable("GATEWAY_INTERFACE")
                    http.env['path'] =          cgilua.servervariable("PATH")
                    http.env['path_info'] =     cgilua.servervariable("PATH_INFO")
                    http.env['pwd'] =           cgilua.servervariable("PWD")
                    http.env['query_string'] =  cgilua.servervariable("QUERY_STRING")
                    http.env['remote_addr'] =   cgilua.servervariable("REMOTE_ADDR")
                    http.env['remote_port'] =   cgilua.servervariable("REMOTE_PORT")
                    http.env['remote_user'] =   cgilua.servervariable("REMOTE_USER")
                    http.env['request_method'] = cgilua.servervariable("REQUEST_METHOD")
                    http.env ['request_uri'] =   cgilua.servervariable("REQUEST_URI")
                    http.env['script_filename'] =cgilua.servervariable("SCRIPT_FILENAME")
                    http.env['script_name'] =   cgilua.servervariable("SCRIPT_NAME")
                    http.env['server_port'] =   cgilua.servervariable("SERVER_PORT")
                    http.env['server_name'] =   cgilua.servervariable("SERVER_NAME")
                    http.env['server_protocol'] = cgilua.servervariable("SERVER_PROTOCOL")
                    http.env['server_software'] = cgilua.servervariable("SERVER_SOFTWARE")
                    http.env['content_type'] =  cgilua.servervariable("CONTENT_TYPE")
                    http.env['content_length'] =cgilua.servervariable("CONTENT_LENGTH")
                    http.env['cookie'] =        parseCookie(cgilua.servervariable("HTTP_COOKIE") or "")
                 else
                    http.env['lang'] = selectLanguage(os.getenv("HTTP_ACCEPT_LANGUAGE"))
                    http.env['auth_type'] =     os.getenv("AUTH_TYPE")
                    http.env['gateway_interface'] = os.getenv("GATEWAY_INTERFACE")
                    http.env['path'] =          os.getenv("PATH")
                    http.env['path_info'] =     os.getenv("PATH_INFO")
                    http.env['pwd'] =           os.getenv("PWD")
                    http.env['query_string'] =  os.getenv("QUERY_STRING")
                    http.env['remote_addr'] =   os.getenv("REMOTE_ADDR")
                    http.env['remote_port'] =   os.getenv("REMOTE_PORT")
                    http.env['remote_user'] =   os.getenv("REMOTE_USER")
                    http.env['request_method'] = os.getenv("REQUEST_METHOD")
                    http.env ['request_uri'] =   os.getenv("REQUEST_URI")
                    http.env['script_filename'] = os.getenv("SCRIPT_FILENAME")
                    http.env['script_name'] =   os.getenv("SCRIPT_NAME")
                    http.env['server_port'] =   os.getenv("SERVER_PORT")
                    http.env['server_name'] =   os.getenv("SERVER_NAME")
                    http.env['server_protocol'] = os.getenv("SERVER_PROTOCOL")
                    http.env['server_software'] = os.getenv("SERVER_SOFTWARE")
                    http.env['content_type'] =  os.getenv("CONTENT_TYPE")
                    http.env['content_length'] = os.getenv("CONTENT_LENGTH")
                    http.env['cookie'] =        parseCookie(os.getenv("HTTP_COOKIE") or "")
                 end
              end

headPrint = function(http, param, value)
               if param ~= nil then
                  http.head[param] = value
               end
            end

bodyPrint = function(http, text, ...)
               if text ~= nil then
                  http.body.text = http.body.text..tostring(text)
                  http:bodyPrint(...)
               end
            end


genOut = function(http)
            http:headPrint("NSGVersion", version)
            if #http.body.text==0 then http.body.text = "\0" end
            if nsgServer == "xavante" then
               cgilua.contentheader("text", "html")
               cgilua.header("Cache-Control","no-store, no-cache, must-revalidate");
              -- cgilua.header("Cache-Control", "post-check=0, pre-check=0");
               for k,v in pairs(http.head) do
                  cgilua.header(k, v)
               end
               cgilua.put(http.body.text);
            else
               io.write("HTTP/1.0  "..tostring(http.head["Status"] or 200).." OK".."\013\010")
               http:headPrint("Cache-Control", "no-store, no-cache, must-revalidate")

               for k,v in pairs(http.head) do
                  if k ~= "Status" then
                     io.write(k,":",v,"\013\010");
                  end
               end
               io.write("\013\010");
               io.write(http.body.text)
            end
         end

genError = function(http, status, ...)
              http.head = {}
             -- headPrint(http, "HTTP/1.0 "..tostring(status).." OK")
              headPrint(http, "Status", tostring(status))

              http.body.text = ""
              http:bodyPrint("<html>")
              http:bodyPrint(...)
              http:bodyPrint("<pre>Env data:\010")
              for k,v in pairs(http.env) do
                 http:bodyPrint(k.."="..v.."\010")
              end
              http:bodyPrint("</pre>")
              http:bodyPrint("<pre>POST data:\010")
              for k,v in pairs(http.data) do
                 http:bodyPrint(k.."="..v.."\010")
              end
              http:bodyPrint("</pre>")
              http:bodyPrint("<pre>Raw post data:\010"..http.raw_post.."</pre>")
              http:bodyPrint("</html>")
              genOut(http)
           end

genFast = function(http, status, ...)
             http.head = {}
             --http.head.print("HTTP/1.0 "..tostring(status).." OK")
             headPrint(http, "Status", tostring(status))

             http.body.text = ""
             http.body.print(...)
             http.genOut()
          end

usec = function ()
          local f=io.popen ("cat /proc/uptime | grep -o '^[0-9]*[.][0-9]*'")
          if f then
             t=f:read("*n")
             f:close()
             return t
          else
             return 0
          end
       end


skeleton = function (http)
               local err
               local ret = ""
               http.data.mode = "xml"
               http:bodyPrint(
                  [[<?xml version="1.0" encoding="UTF-8" ?>
                           <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
                        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
                           <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
                           <meta http-equiv="X-UA-Compatible" content="IE=7" />
                           <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
                           <script src="/jquery.js?]]..version..[[" type="text/javascript" charset="UTF-8" ></script>
                           <script src="/form.js?]]..version..[[" type="text/javascript" charset="UTF-8" ></script>
                           <script src="/boxover.js?]]..version..[[" type="text/javascript"  charset="UTF-8"></script>
                           <script src="/webtty.js?]]..version..[[" type="text/javascript"  charset="UTF-8"></script>
			   <script src="/nsghelp.js?]]..version..[[" type="text/javascript"  charset="UTF-8"></script>
                           <link rel="stylesheet" type="text/css" href="/style.css?]]..version..[["/>
                           <link rel="icon" type="image/x-icon" href="/nsg.ico"/>
                           <link rel="shortcut icon" type="image/x-icon" href="/nsg.ico"/>
                           <head>
                           <title>NSG Web Configuration Manager</title>
                           </head>
                           <script type="text/javascript" charset="UTF-8">
							  
			window.NSGVERSION="]]..version..[[";
			window.activity=0;
                        window.SID=]]..escapeForScript(tonumber(http.data.sesnum or http.env.cookie and http.env.cookie.sesnum) or 0)..[[;
                        window.LOGIN=]]..escapeForScript(tostring(http.data.login or http.env.cookie and http.env.cookie.login~=nil and http.env.cookie.login or ''))..[[;
                        window.NETNS=]]..escapeForScript(tostring(http.data.netns or http.env.cookie and http.env.cookie.netns~=nil and http.env.cookie.netns or ''))..[[;
                        window.PASSWORD=]]..escapeForScript(tostring(http.data.pass or ''))..[[;
                        window.PAGENAME="index.lp";
                        window.LOCALE=]]..escapeForScript(tostring(http.env.lang or "en"))..[[;
                        </script>
                                                  
                                                   <script src="/script.js?]]..version..[[" type="text/javascript"  charset="UTF-8"></script>
                                                   <script type="text/javascript" charset="UTF-8">$(document).ready(loginNSG);  </script>

                                                   <body>
                                             <div class="main">
                                             </div>
					     </body>
                                                   </html>
                                             ]])
            end


loginPage = function (http, status)
               local ls = readpopen([[ls -1 -A /var/run/nsgconfd.*unix | sed 's/\/var\/run\/nsgconfd[.]\{0,1\}\(.*\)\.unix/\1/']])
               local ns = {}
               for k in string.gmatch(ls, "(%w+)") do
                  ns[#ns+1] = k
               end
               ns = #ns>0 and ns or nil

--               http:headPrint("Set-Cookie", "sesnum=;")
               return  nsg.xmlInsertLast(xmlHead("")..'<?xml-stylesheet type="text/xsl" href="style.xsl?'..version..'" ?>\n'..nsg.xmlize("LOGINPAGE",{error = status and luaToHuman(nsg.safeXML(nsg.serialize(status))), devName = devName, hostName = hostName, netns = NETNS, netnslist = (NETNS=="" and ns or nil), safeMode=(0 == os.execute("cat /proc/nsg/env | grep 'safe_mode=yes'") and 'true' or nil)}),
                                         scriptXML([[
                                                         $("html, body").removeClass().addClass("login");
                                                   ]]
                                             )      )
            end


fixCRLF =
   function (s)
      return s~=nil and  tostring(s):gsub("\n( *)(\t?)", function(s,t)
                                                            return'\n'..(t~=''and('\t'):rep(#s+1)or'')
                                                         end or ""
                                       )
   end

splitString =
   function (s)
      s = s or ""
      local out = {}
      local i = 70
      local i2 = 0
      local len = nsg.utf8len(s) or 0
      while i2<len do
         out[#out+1] = nsg.utf8sub(s,i2 + 1, i2 + i)
         i2 = i2 + i
      end
      return out
   end

escapeForScript =
   function (s)
      s = tostring((s ~= nil and s or ''))
      s = splitString(s)
      for k,v in ipairs(s) do
         s[k] = 'deHex("'..nsg.enHex(tostring(v) or "")..'")'
      end
      if #s==0 then
         s[#s+1] = '""'
      end
      return table.concat(s,"+")
   end
script =
   function (s)
      return "<span class=\"hiddenscript\"><textarea class=\"hiddentext\">"..htmlEncode(s or "").."</textarea></span>"
   end

scriptXML =
   function (s)
      return nsg.xmlize("SCRIPT", s or "")
   end

hideCTRL =
   function (s)
      return ("%q"):format(s):gsub("\\\n","\\n");
   end

text =
   function (s)
      return "<span class=\"hiddentext\"><textarea class=\"hiddentext\">"..htmlEncode(hideCTRL(s or "")).."</textarea></span>"
   end

textXML =
   function (s)
      return {TEXT = nsg.enHex(s or "")}
   end

alert =
   function (s, h)
      
      return s~=nil and "alert("..escapeForScript((h and "<pre class='putitle'>"..h.."</pre>" or "").."<pre class='pubody'>"..s.."</pre>")..");" or ""
   end


xmlHead = function(xmlText)
                            return '<?xml version="1.0" encoding="UTF-8" ?>\n'..xmlText
          end


tryGetSession =
   function(http, cookie)
      if cookie then
	 local noSes = {
	    getHTML = true,
	 }
	 if noSes[http.data.command or ''] then
	    return true
	 end
      end
      local user = http.data.login or (cookie and cookie.login) or nil
      user = user and tostring(user) or nil
      local netns = tostring(http.data.netns or (cookie and cookie.netns) or '')
      local sesnum = user and (tonumber(http.data['sesnum.'..netns..'.'..user] or (cookie and cookie['sesnum.'..netns..'.'..user]))) or 0
      if not user then
         return nil
      end

      local ses, err

      if sesnum ~=0 then
         ses, err = conf.open({
                                 sesnum = sesnum,
                                 netns = netns,
                                 user = user,
                                 mode = "xml",
                                 maxRights = (http.data.maxRights or nil),
                                 socktype = 'unix'
                              })
      end

      if ses then
         return ses, err
      else
         if (http.data.command=='start') or (not cookie) then
            if http.data.login and checkPasswd(http.data.login, http.data.pass or "") then
               ses, err = conf.open({
                                       sesnum = 0,
                                       netns = http.data.netns or '',
                                       user = http.data.login or nil,
                                       mode = "xml",
                                       maxRights = (http.data.maxRights or nil),
                                       socktype = 'unix'
                                    })
               if ses then
                  return ses, err
               else
                  return nil, err
               end
            else
               return nil, "incorrect Name or Password"
            end
         end
      end
      return  nil, err
   end


doCmdXML =
   function(ses, http)
      local cmd = http.data.command or 'start'
      local err
      local msg
      local ret = ""
      if ses ~= true then
         http.data.sesnum = ses.sesnum
         http.data.login = ses.user

         ses.timeout = (http.data.timeout or 20) -1
      end
      stdHead(http,"xml")
      local cmdA
      cmdA = {
         logOut =
            function()
               ret = ses:isConfigChanged()
               if (ret and not http.data.force) then
                  local _H = "webCfgNotSavedContinue"
                  msg = xmlHead(nsg.xmlize("NSG", { SCRIPT = 'if (confirm(getHelp("webCfgNotSavedContinue"))) { logOut(true); };' }))
               else
                  pcall(ses.closeSession, ses);
                  msg = xmlHead(nsg.xmlize("NSG", { SCRIPT = [[
                                                          delCookie('login');
                                                          delCookie('sesnum.' + window.NETNS +"." + window.LOGIN );
                                                          delCookie('netns');
                                                          window.location.replace(window.location.toString());
                                                    ]] }))
               end
            end,
         inTree =
            function()
               local ret, err = ses:getConf( (calcValue(http.data.path) or nil), {http={data=http.data, env=http.env}, mode="intree" })
               if type(ret)=="table" then
                  if type(ret.head)=="table" then
                     for k,v in pairs(ret.head) do
                        http:headPrint(k,v)
                     end
                  end
               else
                  ret = {
                     msg = err
                  }
               end
               -- ret in XML or RAW !!!
               msg =  ret.body and (ret.raw and ret.body or xmlHead(ret.body))
               or xmlHead(nsg.xmlize("NSG",{SCRIPT = {
                                               alert(ret.msg),
                                               ret.script
                                         }}))
            end,
         start =
            function()
               local directHTML = ses:getHTMLModule()
               if directHTML then
                  http.data.module = directHTML
                  http.data.path="{}"
                  http.data.command = "getHTML"
                  http.data.subcmd = "startInplace"
                  pcall(ses.closecon, ses)
                  ses = nil
                  cmdA.getHTML()
               else
                  http.data.pagename = nsgPageName
                  http.data.locale = ses:setLocale() or http.data.locale or http.env.lang or "en"
                  ses:setLocale(http.data.locale)
                  http.data.mode = "xml"
                  ses:setMode(http.data.mode)
                  http.data.sessionMessage = (http.data.sessionMessage or "")
                  ret, err = ses:getConf( false, {http={data=http.data, env=http.env}})
             
                  -- ret in XML !!!
                  if ret then
                     msg =  (xmlHead("")..'<?xml-stylesheet type="text/xsl" href="style.xsl?'..version..'" ?>\n'..ret)
                  else
                     msg = loginPage(http, err)
                  end
               end
            end,
         edit =
            function()
               ses:setMode("text")
               ret, err = ses:getConf( (calcValue(http.data.path) or nil), false)
               -- ret in TEXT !!!
               msg =  ret and  xmlHead(nsg.xmlize("EDIT", textXML(ret))) or xmlHead(nsg.xmlize("NSG",{SCRIPT = alert(err)}))
               ses:setMode("xml")
            end,
         getConf =
            function()
               ret, err = ses:getConf( (calcValue(http.data.path) or nil), {http={data=http.data, env=http.env}})
               -- ret in XML !!!
               msg =  ret and xmlHead(ret) or xmlHead(nsg.xmlize("NSG",{SCRIPT = alert(err)}))
            end,
         tty =
            function()
               ret, msg = ses:tty(calcValue(http.data.path) or nil,  http.data.value and http.data.value or http.data.value)
               -- ret in TEXT !!!
               msg =xmlHead(nsg.xmlize("NSG",textXML((ret) or
                                                  (type(ret) == 'boolean' and (not ret) and (msg~="") and  msg) or
                                               ((not ret or  msg=="") and "_C_L_O_S_E_D_") or msg)))
            end,
         setValueSmart =
            function()
		  if  http.data.value == nil or calcValue(http.data.value)==nil then 
		     err, ret, msg = ses:removeKey(calcValue(http.data.path) or nil)
		  else
		     err, ret, msg = ses:setValueSmart(calcValue(http.data.path) or nil, ((http.data.value~=nil) and calcValue(http.data.value)) or ((http.data.value==nil) and nil))
		  end
                  if not err then
		     msg = nsg.xmlInsertLast(xmlHead(msg or ""), ret and nsg.xmlize("SCRIPT", alert(ret)) or "")
                  end        
            end,
         paste =
            function()
               err, msg = ses:paste(calcValue(http.data.path) or nil, http.data.value and (htmlDecode(http.data.value)) or "", nil)
               local scr = {}
               scr[#scr + 1] = not err and  alert(msg or "Error")
               scr[#scr + 1] = 'loadDir(window.execScriptsParam, true);'
               msg = xmlHead(nsg.xmlize("NSG",{SCRIPT = scr}))
            end,
         validate =
            function()
               err, msg = ses:paste(calcValue(http.data.path) or nil, http.data.value and (http.data.value) or "", true)
               msg = xmlHead(nsg.xmlize("NSG",{SCRIPT = alert(msg or "OK")}))
            end,
         newKey =
            function()
               err, msg = ses:newKey(calcValue(http.data.path) or nil, http.data.value and calcValue(http.data.value))
               msg = err and msg or msg and xmlHead(nsg.xmlize("NSG",{SCRIPT = alert(msg)}))
            end,
         insertKey =
            function()
               err, msg = ses:insertKey(calcValue(http.data.path) or nil, http.data.value and calcValue(http.data.value))
               msg = err and msg or  msg and  xmlHead(nsg.xmlize("NSG",{SCRIPT = alert(msg)}))
            end,
         saveConf =
            function()
               err, msg = ses:saveConf(calcValue(http.data.path) or nil)
               msg = err and  xmlHead(nsg.xmlize("NSG",{SCRIPT = alert(err)})) or xmlHead(nsg.xmlize("NSG",{SCRIPT = alert(msg or "Not saved!")}))
            end,
         applyConf =
            function()
               err, msg = ses:applyConf(calcValue(http.data.path) or nil)
               msg =  msg and xmlHead(nsg.xmlize("NSG",{SCRIPT = alert(msg)})) or xmlHead(nsg.xmlize("NSG",{SCRIPT = alert(err and "Ok" or "Fail")}))
            end,
         getManual =
            function()
               msg = ses:getManual(calcValue(http.data.path) or nil, "No manual for this entry.")
               local path = calcValue(http.data.path)
               msg =  msg and xmlHead(nsg.xmlize("NSG",{SCRIPT = alert(msg, table.concat(#path>0 and path  or {"NSG"},"."))})) or ""
            end,
         setLocale =
            function()
               msg = ses:setLocale(http.data.locale)
               msg =  msg and xmlHead(nsg.xmlize("NSG",{SCRIPT = alert(msg)})) or ""
            end,
         getUsage =
            function()
               msg = ses:getUsage(http.data.locale)
               msg =  msg and xmlHead(nsg.xmlize("NSG",{SCRIPT = "window.execScriptsParam.innerHTML="..
                                                        escapeForScript(msg).." + "..
                                                     escapeForScript('<img alt="refresh" tabindex=0 class="brefresh" src="/nil.png">')}))
            end,
         removeKey =
            function()
               err, msg = ses:removeKey(calcValue(http.data.path) or nil)
               msg = err and msg or xmlHead(nsg.xmlize("NSG",{SCRIPT = alert(msg)})) or ""
            end,
         executeTask =
            function()
               err, msg, ret = ses:executeTask(calcValue(http.data.path) or nil, http.data.value and calcValue(http.data.value))
               msg = err and xmlHead(nsg.xmlize("NSG",textXML(msg)))  or  msg and xmlHead(nsg.xmlize("NSG",{SCRIPT = alert(msg)}))
            end,
         getHTML =
            function()
	       ses, err = tryGetSession(http)
               if ses then
                  http.data.pagename = nsgPageName
                  http.data.locale = ses:setLocale() or http.data.locale or http.env.lang or "en"
                  ses:setLocale(http.data.locale)
                  if ses:getHTMLModule(calcValue(http.data.path)) == http.data.module then
                     err, msg =  pcall(require, http.data.module)
                     if err then
			local params = {ses = ses}
			http.data.sesnum = ses.sesnum
                        err, ret, msg = pcall(msg.getHTML, http, params)
		     end
                  else
                     err, msg = nil, "Error: Web module incorrect:"..tostring(module).."<>"..tostring(http.data.module)
                  end
               else
                  err, msg  = nil, err
               end
               msg = err and msg or (msg or "Error")..tostring(ret)
            end,
         error =
            function()
               msg = alertScript("Error command:"..cmd)
            end,
      }

      (cmdA[cmd or "error"] or cmdA.error)()
      if ses then
         pcall(ses.closecon, ses)
      end
      return msg
   end


function main()
   local http = {
      ['env']  = {},

      ['head'] = {
      },

      ['body'] = {
         ['text'] = ""
      },

      ['data'] = {},

      ['raw_post'] = '',
      headPrint = headPrint,
      bodyPrint = bodyPrint
   }

   initEnvData(http)
   initPostData(http)

   if http.env['request_method']:match("[gG][eE][tT]") then
      http.env.cookie.login = nil
      http.env.cookie.netns = nil
      http.data.login = nil
      http.data.netns = nil
      skeleton(http)
      genOut(http)
   else
      local ses, err = tryGetSession(http, http.env.cookie)
      http.data.sessionMessage = err
      if ses then
         if ses ~= true then
            http.data.sesnum = ses.sesnum
            http.env.cookie.sesnum = ses.sesnum
         end
         if http.data.command == "login" then
            skeleton(http)
         else
            http:bodyPrint(doCmdXML(ses, http))
         end
      else
         if http.data.command == "login" then
            skeleton(http)
         elseif http.data.command == "tty" then
            http:bodyPrint(xmlHead(nsg.xmlize("NSG", textXML('_C_L_O_S_E_D_'))))
         elseif http.data.command == "start" and http.data.login==nil then
            http:bodyPrint(loginPage(http))
         elseif  http.data.command == "start" then
            http:bodyPrint(loginPage(http,"Can't open nsgconf session( "..(err or http.data.sessionMessage or "").." )"))
         else
            local _H = "webDoYouWantRestoreSession"
            local _H = "CantOpenSession"
            http:bodyPrint(xmlHead(nsg.xmlize("NSG",{
                                                 SCRIPT = [[
                                                       if (confirm(getHelp("CantOpenSession")+"("+]]..escapeForScript(err or http.data.sessionMessage or "")..[[+ "). "+getHelp("webDoYouWantRestoreSession"))){ reloadNsg();} else {
                                                                   delCookie('login');
                                                                   delCookie('sesnum.' + window.NETNS +"." + window.LOGIN );
                                                                   delCookie('netns');
                                                                   window.location.replace(window.location.toString());
                                                                };]]})))
         end
      end
      genOut(http)
      
      for k,v in pairs(http.data) do
         if type(v)=="table" and v.tmpFile and not v.dontremove then
            os.remove(v.tmpFile)
         end
      end
   end
end

--main()  --This called from external owner script

--io.write(" "..(os.clock()-T1).." " )
